<?php
//########################################################################
//## JP SimpleV2 Skin Category Plugin ####################################
//########################################################################

function getJPsimpleV2SkinCategory($target) {
	global $blogid, $category;
	$totalPosts = getEntriesTotalCount($blogid);
	$categories = getCategories($blogid);
	$target = getJPsimpleV2SkinCategoriesView($totalPosts, $categories, (isset($category) ? $category : true));
	return $target;
}

function getJPsimpleV2SkinCategoriesView($totalPosts, $categories, $selected) {
	global $blogURL, $service, $blog;
	requireModel('blog.category');
	requireLibrary('blog.skin');
	$blogid = getBlogId();
	$categoryCount = 0;
	$categoryCountAll = 0;
	$parentCategoryCount = 0;
	$tree = array('id' => 0, 'label' => getCategoryNameById($blogid, 0), 'value' => $totalPosts, 'link' => "$blogURL/category", 'children' => array());
	foreach ($categories as $category1) {
		$children = array();
		if(doesHaveOwnership() || getCategoryVisibility($blogid, $category1['id']) > 1) {
			foreach ($category1['children'] as $category2) {
				if( doesHaveOwnership() || getCategoryVisibility($blogid, $category2['id']) > 1) {
					array_push($children, 
						array('id' => $category2['id'], 
							'label' => $category2['name'], 
							'value' => (doesHaveOwnership() ? $category2['entriesInLogin'] : $category2['entries']), 
							'link' => "$blogURL/category/" . ($blog['useSloganOnCategory'] ? URL::encode($category2['label'],$service['useEncodedURL']) : $category2['id']), 
							'children' => array()
						)
					);
					$categoryCount = $categoryCount + (doesHaveOwnership() ? $category2['entriesInLogin'] : $category2['entries']);
				}
				$categoryCountAll = $categoryCountAll + (doesHaveOwnership() ? $category2['entriesInLogin'] : $category2['entries']);
			}
			$parentCategoryCount = (doesHaveOwnership() ? $category1['entriesInLogin'] - $categoryCountAll : $category1['entries'] - $categoryCountAll);
			if($category1['id'] != 0) {
				array_push($tree['children'], 
					array('id' => $category1['id'], 
						'label' => $category1['name'], 
						'value' => $categoryCount + $parentCategoryCount, 
						'link' => "$blogURL/category/" . ($blog['useSloganOnCategory'] ? URL::encode($category1['label'],$service['useEncodedURL']) : $category1['id']), 
						'children' => $children)
				);
			}
			$categoryCount = 0;
			$categoryCountAll = 0;
			$parentCategoryCount = 0;
		}
	}
	$categoriesTreeView = getJPsimpleV2SkinPrintTreeView($tree, $selected);
	return $categoriesTreeView;
}

function getJPsimpleV2SkinPrintTreeView($tree, $selected) {
	global $skinSetting;

	requireLibrary('blog.skin');
	requireModel('blog.entry');

	$skin = $skinSetting;
	$embedJava = false;
	if ($embedJava == false) {
		$skin = getCategoriesSkin();
	}

	$categoriesView = '<ul>'.CRLF;
	if ($tree['id'] === $selected) {
		$isSelected = ' class="selected"';
		$onmouseOverOut = "";
	} else {
		$isSelected = '';
		$onmouseOverOut = " onmouseover=\"this.style.backgroundColor='#d9d5c7';\" onmouseout=\"this.style.backgroundColor='';\" ";
	}
	
	$categoriesView .= "<li$isSelected onclick=\"location.href='" . htmlspecialchars($tree['link']) . "';\" {$onmouseOverOut}>&raquo; <b>All category</b>";
	if ($skin['showValue']) $categoriesView .= " <span class=\"c_cnt\">({$tree['value']})</span>";
	$categoriesView .= "</li>".CRLF;

	for ($i=0; $i<count($tree['children']); $i++) {
		$child = $tree['children'][$i];
		
		if ($child['id'] === $selected) {
			$isSelected = ' class="selected"';
			$onmouseOverOut = "";
		} else {
			$isSelected = '';
			$onmouseOverOut = " onmouseover=\"this.style.backgroundColor='#d9d5c7';\" onmouseout=\"this.style.backgroundColor='';\" ";
		}

		$categoriesView .= "<li$isSelected onclick=\"location.href='" . htmlspecialchars($child['link']) . "';\" {$onmouseOverOut}>&raquo; <b>" . htmlspecialchars($child['label']) . "</b>";
		if ($skin['showValue']) $categoriesView .= " <span class=\"c_cnt\">({$child['value']})</span>";
		$categoriesView .= "</li>".CRLF;

		for ($j=0; $j<count($child['children']); $j++) {
			$leaf = $child['children'][$j];

			if ($leaf['id'] === $selected) {
				$isSelected = ' class="selected"';
				$onmouseOverOut = "";
			} else {
				$isSelected = '';
				$onmouseOverOut = " onmouseover=\"this.style.backgroundColor='#d9d5c7';\" onmouseout=\"this.style.backgroundColor='';\" ";
			}
			
			$categoriesView .= "<li$isSelected onclick=\"location.href='" . htmlspecialchars($leaf['link']) . "';\" {$onmouseOverOut}>&raquo; " . htmlspecialchars($leaf['label']);
			if ($skin['showValue']) $categoriesView .= " <span class=\"c_cnt\">({$leaf['value']})</span>";
			$categoriesView .= "</li>".CRLF;
		}
	}
	$categoriesView .= '</ul>';
	return $categoriesView;
}
?>